
///////////////////////////////////////////////////////////////////////////////
//
//	File    : $Id: _ibs.cpp,v 1.6 2001/05/23 17:29:34 epocman Exp $
//	Subject : IBPP, internal Status class implementation
//
///////////////////////////////////////////////////////////////////////////////
//
//	The contents of this file are subject to the Mozilla Public License
//	Version 1.0 (the "License"); you may not use this file except in
//	compliance with the License. You may obtain a copy of the License at
//	http://www.mozilla.org/MPL/
//
//	Software distributed under the License is distributed on an "AS IS"
//	basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
//	License for the specific language governing rights and limitations
//	under the License.
//
//	The Original Code is "IBPP 0.9" and all its associated documentation.
//
//	The Initial Developer of the Original Code is T.I.P. Group S.A.
//	Portions created by T.I.P. Group S.A. are
//	Copyright (C) 2000 T.I.P Group S.A.
//	All Rights Reserved.
//
//	Contributor(s): ______________________________________.
//
///////////////////////////////////////////////////////////////////////////////
//
//	COMMENTS
//	* Tabulations should be set every four characters when editing this file.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef IBPP_WINDOWS
#include <windows.h>
#endif

#include "ibpp.h"
#include "_internals.h"

#ifdef HAS_HDRSTOP
#pragma hdrstop
#endif

#include <stdio.h>

using namespace ibpp_internals;

int _IBS::SqlCode(void)
{
	return (int)(*GDS::gds()->_sqlcode)(_Vector);
}

const char* _IBS::ErrorMessage(void)
{
	char msg[512];
	char sqlmsg[512+64];
	char iscmsg[2048];
    ISC_STATUS* error;
	long sqlcode;

	if (_Message != NULL) return _Message;	// If message compiled, returns it

	// Compiles the message (SQL part)
	sqlcode = (*GDS::gds()->_sqlcode)(_Vector);
	sqlmsg[0] = '\0';
	if (sqlcode != -999)
	{
		(*GDS::gds()->_sql_interprete)((short)sqlcode, msg, sizeof(msg));
		sprintf(sqlmsg, "SQL Message : %ld\n%s.\n\n", sqlcode, msg);
	}

	// Compiles the message (Engine part)
	error = _Vector;
    (*GDS::gds()->_interprete)(msg, &error);
    strcpy(iscmsg, "Engine Message :\n");
    strcat(iscmsg, msg);
    while ((*GDS::gds()->_interprete)(msg, &error))
	{
    	strcat(iscmsg, "\n");
    	strcat(iscmsg, msg);
	}

	_Message = new char[strlen(sqlmsg)+strlen(iscmsg)+1];
	strcpy(_Message, sqlmsg);
	strcat(_Message, iscmsg);

	return _Message;
}

void _IBS::Printf(void)
{
    printf(ErrorMessage());
	printf("\n\n");
}

void _IBS::Reset(void)
{
	for (int i = 0; i < 20; i++) _Vector[i] = 0;
	if (_Message != NULL) delete [] _Message;
	_Message = NULL;
}

_IBS::_IBS()
{
	_Message = NULL;	// Must be NULL or first Reset() call would fail
	Reset();
}

_IBS::~_IBS()
{
	Reset();
}

/** Copy Constructor
*/

_IBS::_IBS(_IBS& copied)
{
	memcpy(_Vector, copied._Vector, sizeof(_Vector));
	_Message = NULL;	// The message will be reconstructed from _vector
						// if ever needed...
}

//
//	EOF
//
