///////////////////////////////////////////////////////////////////////////////
//
//	File    : $Id: _tpb.cpp,v 1.3 2001/05/22 22:26:08 epocman Exp $
//	Subject : IBPP, internal TPB class implementation
//
///////////////////////////////////////////////////////////////////////////////
//
//	The contents of this file are subject to the Mozilla Public License
//	Version 1.0 (the "License"); you may not use this file except in
//	compliance with the License. You may obtain a copy of the License at
//	http://www.mozilla.org/MPL/
//
//	Software distributed under the License is distributed on an "AS IS"
//	basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
//	License for the specific language governing rights and limitations
//	under the License.
//
//	The Original Code is "IBPP 0.9" and all its associated documentation.
//
//	The Initial Developer of the Original Code is T.I.P. Group S.A.
//	Portions created by T.I.P. Group S.A. are
//	Copyright (C) 2000 T.I.P Group S.A.
//	All Rights Reserved.
//
//	Contributor(s): ______________________________________.
//
///////////////////////////////////////////////////////////////////////////////
//
//	COMMENTS
//	* TPB == Transaction Parameter Block/Buffer, see Interbase 6.0 C-API
//	* Tabulations should be set every four characters when editing this file.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef IBPP_WINDOWS
#include <windows.h>
#endif

#include "ibpp.h"
#include "_internals.h"

#ifdef HAS_HDRSTOP
#pragma hdrstop
#endif

#include <stdio.h>

using namespace ibpp_internals;

void _TPB::Insert(char item)
{
    if (_Size == 0)
    {
    	_Buffer = new char[512];
        _Buffer[0] = isc_tpb_version3;
        _Size = 1;
    }
    _Buffer[_Size++] = item;
}

void _TPB::Insert(char item, const char* data)
{
	short len = (short)strlen(data);
    if (_Size == 0)
    {
    	_Buffer = new char[512];
        _Buffer[0] = isc_tpb_version3;
        _Size = 1;
    }
    _Buffer[_Size++] = item;
    strncpy(&_Buffer[_Size], data, len);
    _Size += len;
}

void _TPB::Reset()
{
	if (_Size != 0)
    {
    	delete [] _Buffer;
        _Buffer = NULL;
        _Size = 0;
    }
}

//
//	EOF
//
